Difference between revisions of "Python scripting tutorial/fr"

From FreeCAD Documentation
Jump to navigation Jump to search
 
(52 intermediate revisions by 3 users not shown)
Line 1: Line 1:
 
<languages/>
 
<languages/>
  
{{docnav/fr|[[Introduction to Python/fr|Introduction au langage Python]]|[[FreeCAD Scripting Basics/fr|Débuter avec les scripts]]}}
+
{{docnav/fr|[[Introduction to Python/fr|Introduction au langage Python]]|[[FreeCAD Scripting Basics/fr|Débuter avec les scripts FreeCAD]]}}
  
 
{{TOCright}}
 
{{TOCright}}
Line 7: Line 7:
 
==Introduction==
 
==Introduction==
  
[https://en.wikipedia.org/wiki/Python_%28programming_language%29 Python] est un langage de programmation qui est relativement facile à apprendre et à comprendre. Il est open-source et multi-plateforme et peut être utilisé à de nombreuses fins : des scripts shell simples aux programmes très complexes. Mais son utilisation la plus répandue se trouve dans le langage de script intégré dans d'autres applications. C'est ainsi qu'il est utilisé dans FreeCAD. Depuis la [[Python_console/fr|console Python]], ou depuis des scripts personnalisés, vous pouvez contrôler FreeCAD et lui faire effectuer des opérations très complexes.
+
[https://en.wikipedia.org/wiki/Python_%28programming_language%29 Python] est un langage de programmation qui est relativement facile à apprendre et à comprendre. Il est open-source, multi-plateforme et peut être utilisé à de nombreuses fins : des scripts shell simples aux programmes très complexes. Mais son utilisation la plus répandue se trouve dans le langage de script intégré dans d'autres applications. C'est ainsi qu'il est utilisé dans FreeCAD. Depuis la [[Python_console/fr|console Python]], ou depuis des scripts personnalisés, vous pouvez contrôler FreeCAD et lui faire effectuer des opérations très complexes.
  
 
Par exemple, à partir d'un script Python, vous pouvez :
 
Par exemple, à partir d'un script Python, vous pouvez :
Line 127: Line 127:
 
FreeCAD a été conçu pour pouvoir également être utilisé sans son interface utilisateur, en tant qu'application en ligne de commande. Presque chaque objet dans FreeCAD se compose donc de deux parties : un {{incode|Object}} (objet), sa composante "géométrie" et un {{incode|ViewObject}} (Vue de l'objet), sa composante "visuelle". Lorsque vous travaillez en mode ligne de commande, la partie géométrique est présente, mais la partie visuelle est désactivée.
 
FreeCAD a été conçu pour pouvoir également être utilisé sans son interface utilisateur, en tant qu'application en ligne de commande. Presque chaque objet dans FreeCAD se compose donc de deux parties : un {{incode|Object}} (objet), sa composante "géométrie" et un {{incode|ViewObject}} (Vue de l'objet), sa composante "visuelle". Lorsque vous travaillez en mode ligne de commande, la partie géométrique est présente, mais la partie visuelle est désactivée.
  
<div class="mw-translate-fuzzy">
+
Pour illustrer le concept, observons notre objet cube. Les propriétés géométriques du cube, telles que ses dimensions, sa position, etc. sont stockées dans {{incode|Object}}. Alors que ses propriétés visuelles, telles que sa couleur, son épaisseur de ligne, etc. sont stockées dans {{incode|ViewObject}}. Cela correspond aux onglets '''Données''' et '''Vue''' dans l'[[Property_editor/fr|Éditeur de propriétés]]. La partie ViewObject d'un objet est accessible comme ceci :
Pour illustrer ce concept, voyons notre objet '''box''', les propriétés géométriques du box, comme ses dimensions, sa position, etc .. sont stockés dans l''''Object''', tandis que ses propriétés visuelles, telles que sa couleur, l'épaisseur de la ligne, etc. sont stockées dans '''ViewObject'''. <br />
 
Tout ces paramètres sont visibles (et modifiables) dans la fenêtre '''Propriété--> onglets''' "'''Vue'''" et "'''Données'''".<br />
 
La commande '''ViewObject''' est accessible comme ceci :
 
</div>
 
  
 
{{Code|code=
 
{{Code|code=
 
vo = box.ViewObject
 
vo = box.ViewObject
 
}}
 
}}
<div class="mw-translate-fuzzy">
+
Vous pouvez également modifier les propriétés de l'onglet '''Vue''' :
Vous pouvez également modifier les propriétés de l'onglet "Vue" :
 
</div>
 
  
 
{{Code|code=
 
{{Code|code=
Line 146: Line 140:
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
+
Lorsque vous démarrez FreeCAD, la console Python charge déjà deux modules de base : {{incode|FreeCAD}} et {{incode|FreeCADGui}} (qui sont également accessibles par leurs raccourcis {{incode|App}} et {{incode|Gui}}). Ils contiennent toutes sortes de fonctionnalités génériques pour travailler avec des documents et leurs objets. Pour illustrer notre concept, voyez que {{incode|FreeCAD}} et {{incode|FreeCADGui}} contiennent à la fois un attribut {{incode|ActiveDocument}}, qui est le document actuellement ouvert. {{incode|FreeCAD.ActiveDocument}} et {{incode|FreeCADGui.ActiveDocument}} ne sont cependant pas le même objet. Ce sont les deux composants d'un document FreeCAD et ils contiennent différents attributs et méthodes. Par exemple, {{incode|FreeCADGui.ActiveDocument}} contient {{incode|ActiveView}}, qui est la [[3D_view/fr|Vue 3D]] actuellement ouverte.
Lorsque vous démarrez FreeCAD, la console python charge 2 modules de base : '''FreeCAD''' et '''FreeCADGui''' (qui peuvent également être consultés par leurs raccourcis '''App''' et '''Gui'''). Ils contiennent toutes sortes de fonctionnalités génériques pour travailler avec des documents et leurs objets. Pour illustrer notre concept, observez que '''FreeCAD''' et '''FreeCADGui''' contiennent un attribut '''ActiveDocument''', qui est le document courant. '''FreeCAD.ActiveDocument''' et '''FreeCADGui.ActiveDocument''' ne sont pas le même objet. Ce sont, les deux composantes d'un document FreeCAD, et ils contiennent des attributs et des méthodes différentes.<br />
 
Par exemple, '''FreeCADGui.ActiveDocument''' contient '''ActiveView''', qui est la vue 3D actuellement ouverte.
 
</div>
 
  
[[#top|top]]
+
[[#top|En haut]]
  
<div class="mw-translate-fuzzy">
 
 
== Les modules ==
 
== Les modules ==
  
Maintenant, vous devez sûrement vous demander qu'est-ce que l'on peut faire d'autre, mis à part "'''Part::Box'''"? <br />
+
La véritable puissance de FreeCAD réside dans ses précieux modules. L'application de base FreeCAD est plus ou moins un conteneur vide. Sans ses modules, elle ne peut guère faire plus que créer de nouveaux documents vides. Chaque module ajoute non seulement de nouveaux ateliers à l'interface, mais également de nouvelles commandes Python et de nouveaux types d'objets. Par conséquent, plusieurs types d'objets différents, voire totalement incompatibles, peuvent coexister dans le même document. Les modules les plus importants de FreeCAD que nous verrons dans ce tutoriel sont : [[Part_Module/fr|Part (Pièce)]], [[Mesh_Module/fr|Mesh (Maillage)]], [[Sketcher_Workbench/fr|Sketcher (Esquisseur)]] et [[Draft_Module/fr|Draft (Planche à dessin)]].
D'origine, l'application FreeCAD n'est qu'un conteneur plus ou moins vide. Sans ses modules, FreeCAD ne peut guère faire plus que de créer de nouveaux documents vides. La véritable puissance de FreeCAD réside dans ses modules. Chaque module ajoute non seulement de nouveaux outils à l'interface, mais, aussi de nouvelles commandes Python et de nouveaux types d'objets. Par conséquent, plusieurs types d'objets différents, voire totalement incompatibles entre eux peuvent parfaitement coexister dans le même document. <br />
 
Les modules les plus importants dans FreeCAD, que nous allons voir dans ce tutoriel, sont [[Part Module/fr|Part Module (Atelier Pièce)]], [[Mesh Module/fr|Mesh Module (Atelier Maillage)]], [[Sketcher Workbench/fr|Sketcher Workbench (Atelier Sketcher (Esquisse))]] ou [[Draft_Module/fr|Draft Module (Planche à dessin)]].
 
</div>
 
  
The true power of FreeCAD lies in its faithful modules. The FreeCAD base application is more or less an empty container. Without its modules it can do little more than create new, empty documents. Each module not only adds new workbenches to the interface, but also new Python commands and new object types. As a result several different, and even totally incompatible, object types can coexist in the same document. The most important modules in FreeCAD that we'll look at in this tutorial are: [[Part_Module|Part]], [[Mesh_Module|Mesh]], [[Sketcher_Workbench|Sketcher]] and [[Draft_Module|Draft]].
+
[[Sketcher_Workbench/fr|Sketcher (Atelier Esquisse)]] et [[Draft_Module/fr|Draft (Atelier Planche à dessin)]] utilisent tous deux le module [[Part_Module/fr|Part (Atelier Pièce)]] pour créer et gérer leur géométrie. Tandis que [[Mesh_Module/fr|Mesh (Atelier Maillage)]] est totalement indépendant et gère ses propres objets. Plus d'informations à ce sujet ci-dessous.
  
<div class="mw-translate-fuzzy">
+
Vous pouvez vérifier tous les types d'objets de base disponibles pour le document actuel comme ceci :
[[Sketcher Workbench/fr|Atelier Sketcher (Esquisse)]] et [[Draft_Module/fr|Draft Module (Planche à dessin)]] utilisent tous les deux [[Part Module/fr|Part Module (Atelier Pièce)]] pour créer et gérer leurs objets, qui sont représentés par les bords, modélisation surfacique ou ([http://fr.wikipedia.org/wiki/B-Rep B-Rep]).<br />
 
Alors que [[Mesh Module|Mesh Module (Atelier Maillage)]] est totalement indépendant et gère ses propres objets.<br />
 
Nous en saurons plus tout à l'heure.
 
</div>
 
 
 
Vous pouvez en savoir plus sur tous les types d'objets disponibles dans le document courant comme ceci:
 
  
 
{{Code|code=
 
{{Code|code=
Line 175: Line 156:
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
+
Les différents modules FreeCAD ne sont pas automatiquement chargés dans la console Python. C'est pour éviter d'avoir un démarrage très lent. Les modules sont chargés uniquement lorsque vous en avez besoin. Ainsi, par exemple, pour explorer ce qui se trouve à l'intérieur du module Part :
Même si les différents modules de FreeCAD ont ajoutés leurs types d'objets, les modules ne sont pas automatiquement chargé dans la console python dans le but d'éviter de ralentir le démarrage. Les modules, ne sont chargés que lorsque vous en avez besoin.<br />
 
Ainsi, par exemple, pour explorer ce qui est à l'intérieur de "Part Module" (Atelier Pièce), faites:
 
</div>
 
  
 
{{Code|code=
 
{{Code|code=
Line 185: Line 163:
 
}}
 
}}
  
Mais nous parlerons plus en détail du module "Part module" ci-dessous.
+
Mais nous parlerons plus en détail du module Part ci-dessous.
  
[[#top|top]]
+
[[#top|En haut]]
  
<div class="mw-translate-fuzzy">
 
 
== Mesh (Maillage)==
 
== Mesh (Maillage)==
</div>
 
  
<div class="mw-translate-fuzzy">
+
[https://fr.wikipedia.org/wiki/Mesh_(objet) Un Maillage] est un type d'objet 3D très simple, utilisé par exemple par [https://fr.wikipedia.org/wiki/SketchUp Sketchup], [https://fr.wikipedia.org/wiki/Blender Blender] et [https://fr.wikipedia.org/wiki/Autodesk_3ds_Max 3D Studio Max]. Ils sont composés de 3 éléments : des points (également appelés sommets), des lignes (également appelées arêtes) et des faces. Dans de nombreuses applications, FreeCAD inclus, les faces peuvent n'avoir que 3 sommets. Bien sûr, rien ne vous empêche d'avoir une face plus grande composée de plusieurs triangles coplanaires.
L'outil "[http://en.wikipedia.org/wiki/Polygon_mesh '''Mesh (mailles)''']" est un type d'objet 3D très simple, utilisé par exemple par [http://fr.wikipedia.org/wiki/Google_SketchUp Google SketchUp] , [http://fr.wikipedia.org/wiki/Blender Blender] ou [http://fr.wikipedia.org/wiki/3ds_Max 3D studio Max]. <br />
 
Il est composé de 3 éléments: <br />
 
*1 de [http://fr.wikipedia.org/wiki/Point_(géométrie) '''points'''] (également appelé [http://fr.wikipedia.org/wiki/Sommet_(géométrie) sommets] ou [http://en.wikipedia.org/wiki/Vertex_(geometry) Vertex])<br />
 
*2 de [http://fr.wikipedia.org/wiki/Droite_projective '''lignes'''], (également appelé bords ou arêtes)<br />
 
*3 de [http://fr.wikipedia.org/wiki/Face_(géométrie) '''faces''']. <br />
 
Dans de nombreuses applications, FreeCAD inclus des faces qui possèdent que 3 sommets. Mais bien sûr, rien ne vous empêche d'avoir la face d'un gros avion avec une multitude de triangles [http://fr.wikipedia.org/wiki/Coplanaire coplanaires].
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
Les maillages sont simples, mais comme ils sont simples, vous pouvez facilement en avoir des millions dans un seul document. Cependant, dans FreeCAD, ils sont moins utilisés et sont principalement là pour que vous puissiez importer des objets dans des formats de maillage ({{FileName|.stl}}, {{FileName|.obj}}) à partir d'autres applications. Le module Mesh a également été largement utilisé comme module de test principal au cours du premier mois de la vie de FreeCAD.
Les maillages sont simples, mais parce qu'ils sont simples, vous pouvez facilement en avoir des millions dans un seul document. Cependant, dans FreeCAD, ils sont peu utilisés et la plupart du temps vous pouvez donc importer des objets au format de maillage (.stl, .obj) à partir d’autres applications. Le module Mesh a également été largement utilisé comme module de test principal au départ du développement de FreeCAD.
 
</div>
 
  
L'objet '''Mesh''' et l'objet '''FreeCAD''' sont deux choses totalement différentes. Vous pouvez voir l'objet FreeCAD '''comme conteneur''' d'un Objet Mesh (nous le verrons ci-dessous avec les Objets Part). <br />
+
Les objets Mesh et les objets FreeCAD sont des choses différentes. Vous pouvez voir l'objet FreeCAD comme un conteneur pour un objet Mesh (et comme nous le verrons ci-dessous, pour les objets Part également). Donc pour ajouter un objet Mesh à FreeCAD, nous devons d'abord créer un objet FreeCAD et un objet Mesh, puis ajouter l'objet Mesh à l'objet FreeCAD :
Ainsi, afin d'ajouter un Objet Mesh à FreeCAD, nous devons d'abord créer un Objet FreeCAD, créer un Objet Mesh et ensuite ajouter l'Objet Mesh à l'Objet FreeCAD:
 
  
 
{{Code|code=
 
{{Code|code=
Line 220: Line 186:
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
+
Il s'agit d'un exemple standard qui utilise la méthode {{incode|createSphere()}} pour créer une sphère, mais vous pouvez également créer des maillages personnalisés à partir de zéro en définissant leurs sommets et faces.
Il s'agit ici d'un exemple classique, qui utilise la méthode '''createSphere()''' pour créer automatiquement une sphère mais vous pouvez très bien créer des maillages personnalisés à partir de rien, en définissant leurs sommets et leurs faces.
 
</div>
 
  
[[Mesh Scripting/fr|Ici plus de renseignements sur les scripts Mesh ...]]
+
[[Mesh Scripting/fr|Plus de renseignements sur les scripts Mesh...]]
  
[[#top|top]]
+
[[#top|En haut]]
  
<div class="mw-translate-fuzzy">
+
== Part (Atelier Pièce)==
== Part (Boîte à outils)==
 
  
La [[Part Module/fr| boîte à outils]] est le module le plus puissant de l'ensemble FreeCAD. Il permet de créer et de manipuler des objets [http://fr.wikipedia.org/wiki/B-Rep B-Rep]. Ce type d'objet, contrairement à Mesh, peut avoir une grande variété de composantes. Pour mémoire, B-rep qui signifie '''boundary representation''', ce qui signifie en français '''Représentation par les Bords''' ou '''modélisation surfacique'''. Ces surfaces peuvent être une grande variété d'objets, tel que des surfaces planes ou des surfaces très complexes [http://fr.wikipedia.org/wiki/NURBS NURBS] (pour Non-Uniform Rational Basis Splines). Ils contribuent également à la notion de volume.
+
Le [[Module Part/fr|Module Part]] est le module le plus puissant de FreeCAD. Il vous permet de créer et de manipuler des objets [https://fr.wikipedia.org/wiki/B-Rep BRep]. BRep signifie Boundary Representation ou « Représentation par les Bords ». Un objet BRep est défini par des surfaces qui entourent et définissent un volume intérieur. Contrairement aux maillages, les objets BRep peuvent avoir une grande variété de composants, des faces planes aux surfaces NURBS très complexes.
</div>
 
  
The [[Part Module|Part Module]] is the most powerful module in the whole of FreeCAD. It allows you to create and manipulate [http://en.wikipedia.org/wiki/Boundary_representation BRep] objects. BRep stands for "Boundary Representation". A BRep object is defined by surfaces that enclose and define an inner volume. Unlike meshes, BRep objects can have a wide variety of components from planar faces to very complex NURBS surfaces.
+
Le module Part est basé sur la puissante bibliothèque [https://fr.wikipedia.org/wiki/Open_CASCADE_Technology OpenCasCade], qui permet d'effectuer un large éventail d'opérations complexes sur ces objets, telles que les opérations booléennes, le filetage, les balayages, etc.
  
<div class="mw-translate-fuzzy">
+
Le module Part fonctionne de la même manière que le module Mesh : vous créez un objet FreeCAD, un objet Part, puis ajoutez l'objet Part à l'objet FreeCAD :
La Boîte à outils est basée sur la puissante bibliothèque OpenCascade, qui permet un large éventail d'opérations complexes, qui peuvent être facilement effectuées sur ces objets, tels que, les opérations booléennes, le filetage, balayage, etc ..
 
</div>
 
 
 
Le module fonctionne en partie de la même manière que le module Mesh:<br />
 
Vous créez un Objet FreeCAD puis un Objet Part et après, ajoutez l'Objet Part à l'Objet FreeCAD:
 
  
 
{{Code|code=
 
{{Code|code=
Line 254: Line 211:
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
+
Le module Part (comme le module Mesh) a également un raccourci qui crée automatiquement un objet FreeCAD et lui ajoute une forme, vous pouvez donc raccourcir les trois dernières lignes avec :
Le module Part (tout comme le module Mesh) dispose également d'un raccourci qui crée automatiquement un Objet dans FreeCAD et lui ajoute une forme, vous pouvez ainsi sauter les 3 dernières lignes ci-dessus:
 
</div>
 
  
 
{{Code|code=
 
{{Code|code=
Line 262: Line 217:
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
+
En explorant le contenu de myshape, vous remarquerez de nombreux sous-composants intéressants tels que {{incode|Faces}}, {{incode|Edges}}, {{incode|Vertexes}}, {{incode|Solids}} et {{incode|Shells}} et un large éventail d'opérations de géométrie telles que {{incode|cut}} (soustraction), {{incode|common}} (intersection) ou {{incode|fuse}} (union). La page [[Topological_data_scripting/fr|Script pour création topologique]] explique tout cela en détail.
En explorant le contenu de myShape. dans la fenêtre, vous remarquerez de nombreuses et intéressantes options disponibles comme Faces, Edges, Vertexes, Solids ou Shells et un large éventail d'opérations géométriques telles soustraction, intersection ou union. La page [[Topological data scripting|Script pour les pièces]] explique tout cela en détail.
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
[[Topological_data_scripting/fr|Ici plus de renseignements sur les scripts Part]]
[[Topological data scripting/fr| Ici plus de renseignements sur données topologiques de scripts Part]]
 
</div>
 
  
[[#top|top]]
+
[[#top|En haut]]
 
 
<div class="mw-translate-fuzzy">
 
== Draft (projet de dessin) ==
 
  
FreeCAD propose de nombreux autres modules, tels que [[Sketcher Workbench/fr| Atelier sketcher(esquisse)]] et [[Draft Module/fr| Atelier draft (projet)]] qui créent également des objets Pièce. Ces modules ajoutent des paramètres supplémentaires aux objets créés voire implémentent une toute nouvelle façon de gérer la géométrie de la pièce qu'ils contiennent. Notre exemple de boîte ci-dessus est un exemple parfait d'objet paramétrique. Pour définir cette zone, il vous suffit de spécifier les paramètres hauteur, largeur et longueur. Sur cette base, l’objet calculera automatiquement la forme de sa partie. FreeCAD vous permet de [[Scripted objects|Objets créés par script]].
+
==Draft (Planche à dessin)==
</div>
 
  
FreeCAD features many more modules, such as [[Sketcher_Workbench|Sketcher]] and [[Draft_Module|Draft]], that also create Part objects. These modules add additional parameters to the objects created, or even implement a whole new way to handle the Part geometry in them. Our box example above is a perfect example of a parametric object. All you need to define the box is to specify the parameters height, width and length. Based on those, the object will automatically calculate its Part shape. FreeCAD allows you to [[Scripted_objects|create such objects in Python]].
+
FreeCAD propose de nombreux autres modules tels que l'[[Sketcher_Workbench/fr|atelier Sketch]] et l'[[Draft_Module/fr|atelier Draft]] qui créent également des objets Part (Pièce). Ces modules ajoutent des paramètres supplémentaires aux objets créés, voire implémentent une toute nouvelle façon de gérer la géométrie de la pièce (Part) qu'ils contiennent. Notre exemple de boîte ci-dessus est un exemple parfait d'un objet paramétrique. Tout ce dont vous avez besoin pour définir la boîte est de spécifier les paramètres hauteur, largeur et longueur. Sur la base de ceux-ci, l'objet calculera automatiquement sa forme " de pièce ". FreeCAD vous permet de [[Scripted_objects/fr|créer de tels objets en Python]].
  
<div class="mw-translate-fuzzy">
+
Le [[Module Draft/fr|Module Draft]] ajoute des types d'objets paramétriques 2D (qui sont tous des objets Part) tels que des lignes et des cercles et fournit également des fonctions génériques qui fonctionnent non seulement sur les objets Draft, mais sur tout objet Part. Pour explorer ce qui est disponible, faites simplement :
Le [[Draft Module/fr|Module Draft]] ajoute une série d'objets de types 2D paramétriques (qui sont tous des objets Part) tels que les lignes et les cercles, et fournit également quelques fonctions génériques qui ne travaillent pas seulement sur ​​les objets fabriqués, mais sur n'importe quel objet Part.<br />
 
Pour voir ce qui est disponible, il suffit de faire:
 
</div>
 
  
 
{{Code|code=
 
{{Code|code=
Line 293: Line 237:
 
}}
 
}}
  
[[#top|top]]
+
[[#top|En haut]]
 
 
<div class="mw-translate-fuzzy">
 
== Interface ==
 
  
L'interface utilisateur (Gui) de FreeCAD est faite avec [http://fr.wikipedia.org/wiki/Qt Qt], un puissant système de création d'interface visuelle graphique, chargé de construire et de gérer, commandes, menus, barres d'outils, boutons 3D ... Qt fournit un module appelé [[PySide/fr|PySide]] ([[PySide|en]]) qui permet à Python d'accéder et de modifier les interfaces contruites avec '''Qt''', comme FreeCAD. <br />
+
==Interface==
Essayons de travailler avec l'interface Qt et de construire une simple boîte de dialogue:
 
</div>
 
  
The FreeCAD user interface is made with [http://en.wikipedia.org/wiki/Qt_%28framework%29 Qt], a powerful graphical interface system, responsible for drawing and handling all the controls, menus, toolbars and buttons around the [[3D_view|3D view]]. Qt provides a module, [[PySide]], which allows Python to access and modify Qt interfaces such as FreeCAD's. Let's try to fiddle with the Qt interface and produce a simple dialog:
+
L'interface utilisateur de FreeCAD est faite avec [https://fr.wikipedia.org/wiki/Qt Qt], un puissant système d'interface graphique, chargé de dessiner et de gérer tous les contrôles, menus, barres d'outils et boutons autour de la [[3D_view/fr|Vue 3D]]. Qt fournit un module, [[PySide/fr|PySide]], qui permet à Python d'accéder et de modifier des interfaces Qt telles que celle de FreeCAD. Essayons de jouer avec l'interface Qt et de produire une boîte de dialogue simple :
  
 
{{Code|code=
 
{{Code|code=
Line 309: Line 248:
 
}}
 
}}
  
<div class="mw-translate-fuzzy">
+
Notez que la boîte de dialogue qui apparaît possède l'icône FreeCAD dans sa barre d'outils, ce qui signifie que Qt sait que la commande a été émise depuis l'intérieur de l'application FreeCAD. Il est possible de manipuler n'importe quelle partie de l'interface FreeCAD.
Une boîte de dialogue apparaît et nous voyons aussi l'icone de FreeCAD, ce qui signifie que Qt sait que l'ordre d'affichage de la fenêtre a été fait à l'intérieur de l'application FreeCAD. Nous pouvons donc facilement et partiellement modifier l'interface de FreeCAD.
 
</div>
 
  
<div class="mw-translate-fuzzy">
+
Qt est un système (de construction) d'interface très puissant qui vous permet de faire des choses très complexes. Il possède également des outils faciles à utiliser, tel que Qt Designer, avec lequel vous pouvez concevoir graphiquement des boîtes de dialogue, puis les ajouter à l'interface FreeCAD avec quelques lignes de code Python.
Qt est un système de construction d'interface très puissant qui vous permet de faire des choses très complexes. Qt possède aussi une panoplie d'outils tel que Qt Designer avec lequel vous pouvez concevoir vos boîtes de dialogue graphique et de les ajouter à l'interface de FreeCAD avec quelques lignes de code Python.
 
</div>
 
  
[[PySide/fr|Plus de renseignements sur PyQt ici]] et ici [http://fr.wikipedia.org/wiki/PyQt PyQt]
+
[[PySide/fr|Plus de renseignements sur PySide ici]]
  
[[#top|top]]
+
[[#top|En haut]]
  
<div class="mw-translate-fuzzy">
 
 
== Macros ==
 
== Macros ==
  
Maintenant que vous avez une bonne connaissance des notions de base, où allons-nous placer nos scripts Python ? Comment allons-nous les lancer à partir de FreeCAD? <br />
+
Maintenant que vous avez une bonne compréhension des bases, où allons-nous conserver nos scripts Python et comment allons-nous les lancer dans FreeCAD ? Il existe un mécanisme simple pour cela, appelé [[Macros/fr|Macros]]. Une macro est un script Python qui peut être ajouté à une barre d'outils et lancé via un clic de souris. FreeCAD vous fournit un éditeur de texte simple ({{MenuCommand|Macro → Macros... → Créer}}) où vous pouvez écrire ou coller des scripts. Une fois le script terminé, utilisez {{MenuCommand|Outils → Personnaliser... → Macros}} pour définir un bouton qui pourra être ajouté aux barres d'outils.
Il y a pour cela un mécanisme appelé [[Macros/fr|Macros]]. Une macro est tout simplement un script en Python qui peut être ensuite ajouté à la barre d'outils et lancé à partir d'un simple clic de souris.<br />
 
FreeCAD est fournit avec un petit éditeur de texte (Macro → Macros → Créer) où vous pouvez écrire ou coller des scripts. Une fois le script terminé, allez dans '''Outils → Personnaliser → Macros''' où vous pouvez définir un bouton pour votre macro puis ajouter ce bouton à la barre d'outils.
 
</div>
 
  
Now that you have a good understanding of the basics, where are we going to keep our Python scripts, and how are we going to launch them inside FreeCAD? There is an easy mechanism for that, called [[Macros|Macros]]. A macro is a Python script that can be added to a toolbar and launched via a mouse click. FreeCAD provides you with a simple text editor ({{MenuCommand|Macro → Macros... → Create}}) where you can write or paste scripts. Once the script is done, use {{MenuCommand|Tools → Customize... → Macros}} to define a button for it that can be added to toolbars.
+
Vous êtes maintenant prêt pour des scripts FreeCAD plus approfondis. Alors rendez-vous sur le [[Power_users_hub/fr|Hub pour utilisateurs expérimentés]] !
  
<div class="mw-translate-fuzzy">
+
[[#top|En haut]]
Vous êtes maintenant prêt pour un script FreeCAD plus approfondi. Rendez-vous sur la [[Power users hub/fr|Documentation pour utilisateurs avancés]]!
 
</div>
 
 
 
[[#top|top]]
 
  
<div class="mw-translate-fuzzy">
+
{{docnav/fr|[[Introduction to Python/fr|Introduction au langage Python]]|[[FreeCAD Scripting Basics/fr|Débuter avec les scripts FreeCAD]]}}
{{docnav/fr|[[Introduction to Python/fr|Introduction to Python]]|[[FreeCAD Scripting Basics/fr|FreeCAD Scripting Basics]]}}
 
</div>
 
  
 
{{Powerdocnavi{{#translation:}}}}
 
{{Powerdocnavi{{#translation:}}}}
[[Category:Python_Code{{#translation:}}]]
+
[[Category:Developer Documentation{{#translation:}}]]
 +
[[Category:Python Code{{#translation:}}]]
 
{{clear}}
 
{{clear}}

Latest revision as of 13:41, 6 June 2020

Other languages:
Bahasa Indonesia • ‎Deutsch • ‎English • ‎Türkçe • ‎español • ‎français • ‎italiano • ‎polski • ‎português • ‎română • ‎čeština • ‎русский • ‎中文(中国大陆)‎ • ‎日本語

Introduction

Python est un langage de programmation qui est relativement facile à apprendre et à comprendre. Il est open-source, multi-plateforme et peut être utilisé à de nombreuses fins : des scripts shell simples aux programmes très complexes. Mais son utilisation la plus répandue se trouve dans le langage de script intégré dans d'autres applications. C'est ainsi qu'il est utilisé dans FreeCAD. Depuis la console Python, ou depuis des scripts personnalisés, vous pouvez contrôler FreeCAD et lui faire effectuer des opérations très complexes.

Par exemple, à partir d'un script Python, vous pouvez :

  • Créer de nouveaux objets.
  • Modifier les objets existants.
  • Modifier la représentation 3D de ces objets.
  • Modifier l'interface de FreeCAD.

Il existe plusieurs façons d'utiliser Python dans FreeCAD :

  • Depuis l'interpréteur Python de FreeCAD, où vous pouvez exécuter du code dans une interface du style " ligne de commande ".
  • Depuis les macros, qui sont un moyen pratique d'ajouter rapidement un outil manquant à l'interface FreeCAD.
  • A partir de scripts externes, qui peuvent être utilisés pour créer des solutions assez complexes, même des Ateliers entiers.

Dans ce tutoriel, nous allons travailler sur quelques exemples de base pour vous aider à démarrer, mais il y a beaucoup plus de documentations sur les scripts Python disponibles sur ce wiki. Si vous êtes totalement nouveau sur Python et que vous voulez comprendre comment cela fonctionne, nous avons également une Introduction à Python.

Avant de continuer avec les scripts Python, allez dans la fenêtre Edit → Préférences → Général → Fenêtre de sortie et cochez les deux cases :

  • Rediriger les messages internes Python vers la vue rapport.
  • Rediriger les erreurs internes de Python vers la vue rapport.

Accédez ensuite à Affichage → Panneau et vérifiez :

  • Vue de rapport coché.

Ecrire du code Python

Il existe deux façons d'écrire du code Python dans FreeCAD. Dans la Console Python (sélectionnez le menuAffichage → Panneau → Console Python) ou dans l'éditeur de Macro (sélectionnez Macro → Macros … dans le menu). Dans la console vous écrivez les commandes Python une par une, en les exécutant en appuyant sur Entrée, tandis que les macros peuvent contenir du code plus complexe composé de plusieurs lignes, exécuté uniquement lorsque la macro est démarrée.

Screenshot pythoninterpreter.jpg

La console Python FreeCAD


Dans ce tutoriel vous pouvez utiliser les deux méthodes. Vous pouvez copier-coller chaque ligne dans la console Python puis appuyer sur Entrée, ou copier-coller le code entier dans une nouvelle fenêtre Macro.

En haut

Exploration de FreeCAD

Commençons par créer un nouveau document vierge :

doc = FreeCAD.newDocument()

Si vous écrivez dans la console Python FreeCAD, vous remarquerez que dès que vous tapez FreeCAD. une fenêtre apparaît, permettant de compléter rapidement le reste de votre ligne. Encore mieux, chaque entrée de la liste de saisie semi-automatique a une info-bulle expliquant ce qu'elle fait. Cela facilite l'exploration des fonctionnalités disponibles. Avant de choisir newDocument, jetez un œil aux autres options.

Screenshot classbrowser.jpg

Le mécanisme de saisie semi-automatique de la console Python FreeCAD


Maintenant notre nouveau document sera créé. Cela revient à appuyer sur le bouton Std New.svg Std New dans la barre d'outils. En fait, la plupart des boutons de FreeCAD ne font rien d'autre que d'exécuter une ou plusieurs lignes de code Python. Encore mieux, vous pouvez définir une option dans Édition → Préférences → Général → Macro avec Montrer les commandes du script dans la console Python. Cela affichera dans la console tout le code Python exécuté lorsque vous pressez les boutons. Très utile pour apprendre à reproduire des actions dans Python.

Maintenant revenons à notre document et voyons ce que nous pouvons faire avec lui :

doc.

Explorez les options disponibles. Habituellement, les noms qui commencent par une majuscule sont des attributs, ils contiennent une valeur, tandis que les noms qui commencent par une minuscule sont des fonctions (également appelées méthodes) ; ils "font quelque chose". Les noms commençant par un trait de soulignement sont généralement là pour le fonctionnement interne du module et vous ne devriez pas vous en soucier. Utilisons l'une des méthodes pour ajouter un nouvel objet à notre document :

box = doc.addObject("Part::Box", "myBox")

Rien ne se passe. Pourquoi ? Parce que FreeCAD est conçu pour de gros projets. Un jour, il fonctionnera avec des centaines d'objets complexes, tous dépendants les uns des autres. Faire un petit changement quelque part pourrait avoir un grand impact, vous devrez peut-être recalculer tout le document, ce qui pourrait prendre du temps. Pour cette raison, presque aucune commande ne met automatiquement à jour la scène. Vous devez le faire manuellement :

doc.recompute()

Maintenant notre boîte est apparue. De nombreux boutons qui ajoutent des objets dans FreeCAD font en fait deux choses : ajouter l'objet et recalculer. Si vous avez activé l'option Montrer les commandes du script dans la console Python ci-dessus, essayez d'ajouter une sphère avec le bouton GUI, vous verrez les deux lignes de code Python s'exécuter l'une après l'autre.

Explorons maintenant le contenu de notre boîte :

box.

Vous verrez immédiatement un certain nombre de choses très intéressantes telles que :

box.Height

Cela affichera la hauteur actuelle de notre boîte. Maintenant, essayons de changer cela :

box.Height = 5

Si vous sélectionnez votre boîte avec la souris, vous verrez que dans l'Éditeur de propriétés, sous l'onglet Données, notre propriété DonnéesHauteur apparaît. Toutes les propriétés d'un objet FreeCAD qui y apparaissent (et également sur l'onglet Vue, nous développerons plus tard), sont également directement accessibles par Python, par leur nom, comme nous l'avons fait avec notre propriété DonnéesHauteur. Essayez de changer les autres dimensions de la boîte.

En haut

Vecteurs et placements

Les vecteurs sont un concept tout à fait fondamental dans toute application 3D. Un vecteur est une liste de 3 nombres (x, y et z), décrivant un point ou une position dans l'espace 3D. Beaucoup de choses peuvent être faites avec des vecteurs, tels que des additions, des soustractions, des projections et beaucoup plus. Dans FreeCAD, les vecteurs fonctionnent comme ceci :

myvec = FreeCAD.Vector(2, 0, 0)
myvec.x
myvec.y
othervec = FreeCAD.Vector(0, 3, 0)
sumvec = myvec.add(othervec)

Une autre caractéristique commune des objets FreeCAD est leur placement. Chaque objet possède une propriété DonnéesPlacement, qui contient les DonnéesBase (position) et les DonnéesRotation (orientation) de l'objet. Elle est facile à manipuler, par exemple pour déplacer notre objet :

box.Placement
box.Placement.Base
box.Placement.Base = sumvec
 
otherpla = FreeCAD.Placement()
box.Placement = otherpla

Avant d'aller plus loin, vous devez comprendre quelques concepts importants.

En haut

Application et Interface Utilisateur

FreeCAD a été conçu pour pouvoir également être utilisé sans son interface utilisateur, en tant qu'application en ligne de commande. Presque chaque objet dans FreeCAD se compose donc de deux parties : un Object (objet), sa composante "géométrie" et un ViewObject (Vue de l'objet), sa composante "visuelle". Lorsque vous travaillez en mode ligne de commande, la partie géométrique est présente, mais la partie visuelle est désactivée.

Pour illustrer le concept, observons notre objet cube. Les propriétés géométriques du cube, telles que ses dimensions, sa position, etc. sont stockées dans Object. Alors que ses propriétés visuelles, telles que sa couleur, son épaisseur de ligne, etc. sont stockées dans ViewObject. Cela correspond aux onglets Données et Vue dans l'Éditeur de propriétés. La partie ViewObject d'un objet est accessible comme ceci :

vo = box.ViewObject

Vous pouvez également modifier les propriétés de l'onglet Vue :

vo.Transparency = 80
vo.hide()
vo.show()

Lorsque vous démarrez FreeCAD, la console Python charge déjà deux modules de base : FreeCAD et FreeCADGui (qui sont également accessibles par leurs raccourcis App et Gui). Ils contiennent toutes sortes de fonctionnalités génériques pour travailler avec des documents et leurs objets. Pour illustrer notre concept, voyez que FreeCAD et FreeCADGui contiennent à la fois un attribut ActiveDocument, qui est le document actuellement ouvert. FreeCAD.ActiveDocument et FreeCADGui.ActiveDocument ne sont cependant pas le même objet. Ce sont les deux composants d'un document FreeCAD et ils contiennent différents attributs et méthodes. Par exemple, FreeCADGui.ActiveDocument contient ActiveView, qui est la Vue 3D actuellement ouverte.

En haut

Les modules

La véritable puissance de FreeCAD réside dans ses précieux modules. L'application de base FreeCAD est plus ou moins un conteneur vide. Sans ses modules, elle ne peut guère faire plus que créer de nouveaux documents vides. Chaque module ajoute non seulement de nouveaux ateliers à l'interface, mais également de nouvelles commandes Python et de nouveaux types d'objets. Par conséquent, plusieurs types d'objets différents, voire totalement incompatibles, peuvent coexister dans le même document. Les modules les plus importants de FreeCAD que nous verrons dans ce tutoriel sont : Part (Pièce), Mesh (Maillage), Sketcher (Esquisseur) et Draft (Planche à dessin).

Sketcher (Atelier Esquisse) et Draft (Atelier Planche à dessin) utilisent tous deux le module Part (Atelier Pièce) pour créer et gérer leur géométrie. Tandis que Mesh (Atelier Maillage) est totalement indépendant et gère ses propres objets. Plus d'informations à ce sujet ci-dessous.

Vous pouvez vérifier tous les types d'objets de base disponibles pour le document actuel comme ceci :

doc.supportedTypes()

Les différents modules FreeCAD ne sont pas automatiquement chargés dans la console Python. C'est pour éviter d'avoir un démarrage très lent. Les modules sont chargés uniquement lorsque vous en avez besoin. Ainsi, par exemple, pour explorer ce qui se trouve à l'intérieur du module Part :

import Part
Part.

Mais nous parlerons plus en détail du module Part ci-dessous.

En haut

Mesh (Maillage)

Un Maillage est un type d'objet 3D très simple, utilisé par exemple par Sketchup, Blender et 3D Studio Max. Ils sont composés de 3 éléments : des points (également appelés sommets), des lignes (également appelées arêtes) et des faces. Dans de nombreuses applications, FreeCAD inclus, les faces peuvent n'avoir que 3 sommets. Bien sûr, rien ne vous empêche d'avoir une face plus grande composée de plusieurs triangles coplanaires.

Les maillages sont simples, mais comme ils sont simples, vous pouvez facilement en avoir des millions dans un seul document. Cependant, dans FreeCAD, ils sont moins utilisés et sont principalement là pour que vous puissiez importer des objets dans des formats de maillage (.stl, .obj) à partir d'autres applications. Le module Mesh a également été largement utilisé comme module de test principal au cours du premier mois de la vie de FreeCAD.

Les objets Mesh et les objets FreeCAD sont des choses différentes. Vous pouvez voir l'objet FreeCAD comme un conteneur pour un objet Mesh (et comme nous le verrons ci-dessous, pour les objets Part également). Donc pour ajouter un objet Mesh à FreeCAD, nous devons d'abord créer un objet FreeCAD et un objet Mesh, puis ajouter l'objet Mesh à l'objet FreeCAD :

import Mesh
mymesh = Mesh.createSphere()
mymesh.Facets
mymesh.Points
 
meshobj = doc.addObject("Mesh::Feature", "MyMesh")
meshobj.Mesh = mymesh
doc.recompute()

Il s'agit d'un exemple standard qui utilise la méthode createSphere() pour créer une sphère, mais vous pouvez également créer des maillages personnalisés à partir de zéro en définissant leurs sommets et faces.

Plus de renseignements sur les scripts Mesh...

En haut

Part (Atelier Pièce)

Le Module Part est le module le plus puissant de FreeCAD. Il vous permet de créer et de manipuler des objets BRep. BRep signifie Boundary Representation ou « Représentation par les Bords ». Un objet BRep est défini par des surfaces qui entourent et définissent un volume intérieur. Contrairement aux maillages, les objets BRep peuvent avoir une grande variété de composants, des faces planes aux surfaces NURBS très complexes.

Le module Part est basé sur la puissante bibliothèque OpenCasCade, qui permet d'effectuer un large éventail d'opérations complexes sur ces objets, telles que les opérations booléennes, le filetage, les balayages, etc.

Le module Part fonctionne de la même manière que le module Mesh : vous créez un objet FreeCAD, un objet Part, puis ajoutez l'objet Part à l'objet FreeCAD :

import Part
myshape = Part.makeSphere(10)
myshape.Volume
myshape.Area

shapeobj = doc.addObject("Part::Feature", "MyShape")
shapeobj.Shape = myshape
doc.recompute()

Le module Part (comme le module Mesh) a également un raccourci qui crée automatiquement un objet FreeCAD et lui ajoute une forme, vous pouvez donc raccourcir les trois dernières lignes avec :

Part.show(myshape)

En explorant le contenu de myshape, vous remarquerez de nombreux sous-composants intéressants tels que Faces, Edges, Vertexes, Solids et Shells et un large éventail d'opérations de géométrie telles que cut (soustraction), common (intersection) ou fuse (union). La page Script pour création topologique explique tout cela en détail.

Ici plus de renseignements sur les scripts Part

En haut

Draft (Planche à dessin)

FreeCAD propose de nombreux autres modules tels que l'atelier Sketch et l'atelier Draft qui créent également des objets Part (Pièce). Ces modules ajoutent des paramètres supplémentaires aux objets créés, voire implémentent une toute nouvelle façon de gérer la géométrie de la pièce (Part) qu'ils contiennent. Notre exemple de boîte ci-dessus est un exemple parfait d'un objet paramétrique. Tout ce dont vous avez besoin pour définir la boîte est de spécifier les paramètres hauteur, largeur et longueur. Sur la base de ceux-ci, l'objet calculera automatiquement sa forme " de pièce ". FreeCAD vous permet de créer de tels objets en Python.

Le Module Draft ajoute des types d'objets paramétriques 2D (qui sont tous des objets Part) tels que des lignes et des cercles et fournit également des fonctions génériques qui fonctionnent non seulement sur les objets Draft, mais sur tout objet Part. Pour explorer ce qui est disponible, faites simplement :

import Draft
rec = Draft.makeRectangle(5, 2)
mvec = FreeCAD.Vector(4, 4, 0)
Draft.move(rec, mvec)
Draft.move(box, mvec)

En haut

Interface

L'interface utilisateur de FreeCAD est faite avec Qt, un puissant système d'interface graphique, chargé de dessiner et de gérer tous les contrôles, menus, barres d'outils et boutons autour de la Vue 3D. Qt fournit un module, PySide, qui permet à Python d'accéder et de modifier des interfaces Qt telles que celle de FreeCAD. Essayons de jouer avec l'interface Qt et de produire une boîte de dialogue simple :

from PySide import QtGui
QtGui.QMessageBox.information(None, "Apollo program", "Houston, we have a problem")

Notez que la boîte de dialogue qui apparaît possède l'icône FreeCAD dans sa barre d'outils, ce qui signifie que Qt sait que la commande a été émise depuis l'intérieur de l'application FreeCAD. Il est possible de manipuler n'importe quelle partie de l'interface FreeCAD.

Qt est un système (de construction) d'interface très puissant qui vous permet de faire des choses très complexes. Il possède également des outils faciles à utiliser, tel que Qt Designer, avec lequel vous pouvez concevoir graphiquement des boîtes de dialogue, puis les ajouter à l'interface FreeCAD avec quelques lignes de code Python.

Plus de renseignements sur PySide ici

En haut

Macros

Maintenant que vous avez une bonne compréhension des bases, où allons-nous conserver nos scripts Python et comment allons-nous les lancer dans FreeCAD ? Il existe un mécanisme simple pour cela, appelé Macros. Une macro est un script Python qui peut être ajouté à une barre d'outils et lancé via un clic de souris. FreeCAD vous fournit un éditeur de texte simple (Macro → Macros... → Créer) où vous pouvez écrire ou coller des scripts. Une fois le script terminé, utilisez Outils → Personnaliser... → Macros pour définir un bouton qui pourra être ajouté aux barres d'outils.

Vous êtes maintenant prêt pour des scripts FreeCAD plus approfondis. Alors rendez-vous sur le Hub pour utilisateurs expérimentés !

En haut